﻿#targetengine "session"

	var myParentFolder = myGetScriptPath()
	TestMyLoad = false
	
	try { TestMyLoad = !ToLoadCommon }
	catch (err) {TestMyLoad = false}
	
	if (!TestMyLoad) {
	
			myCommonFile = new File(myParentFolder+"/MT-Common1-08.jsxbin")
			
			if (!myCommonFile.exists) {
				myCommonFile = new File(myParentFolder+"/MT-Common1-08.jsx")
				}
	
			try {
				app.doScript(myCommonFile, ScriptLanguage.JAVASCRIPT)
				TestMyLoad = true
				}
			catch (err) {
				TestMyLoad = false
				alert(err+"\nНе удается загрузить файл с основным кодом.\nСкрипт работать не будет!", "MT-Script 1-08", true)
				}
		
	}

	if (TestMyLoad) {
			if (GlobalScriptPath) {mainNew()}
			else {alert(GlStr, "MT-Script 1-08", true)}
		}


//*******************************************************************************//


function mainNew() {	
	
	#include "MT-Load.jsxinc"
	
   var myDocument = app.activeDocument

   with (app.activeDocument.viewPreferences)
	{
      myOldXUnits = horizontalMeasurementUnits;
      myOldYUnits = verticalMeasurementUnits;

      horizontalMeasurementUnits = MeasurementUnits.POINTS;
      verticalMeasurementUnits = MeasurementUnits.POINTS;
    } 
	
try {
    var mySelection = myDocument.selection[0]
	switch (mySelection.constructor.name) {
		case "Rectangle":
		case "WMF":
		case "EPS":
			myEditEqScript = new File(myParentFolder+"/MT-EditEq1-08.jsxbin")
			
			if (!myEditEqScript.exists) {
				myEditEqScript = new File(myParentFolder+"/MT-EditEq1-08.jsx")
				}
			if (myEditEqScript.exists) {app.doScript(myEditEqScript, ScriptLanguage.JAVASCRIPT)}
				else {alert("Не удалось запустить скрипт MT-EditEq1-08\nдля редактирования выбранной формулы", "MT-Script 1-08", true)}
			break;
		case "Text":
		case "TextStyleRange":
		case "Paragraph":
		case "InsertionPoint":
		case "Character":
		case "Cell":
			if (MyNewEquation_VBA(mySelection, myContinueFlag) == true)  {
				 TreatObject(app.activeDocument.links.item(-1).parent.parent.parent, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
				 }
			break;
		}	
	}
    catch(err)
	{ 
		if (err.description.search("undefined") == 0) {
			var myActivePage = myDocument.layoutWindows[0].activePage
		
			NewFilePath = FindFreeEquation(myPath, myContinueFlag)
			if (NewFilePath != "") {
				
				var myNewFile = File(NewFilePath)
				var myOldFileDataTime = myNewFile.modified.getSeconds() + myNewFile.modified.getMinutes()*60
				
				Start_MathType_Run (NewFilePath)

				if (myContinueFlag) {MyDialog("Если Вы набрали формулу, продолжаем")}
				
				var myNewFileDataTime = myNewFile.modified.getSeconds() + myNewFile.modified.getMinutes()*60
				
				if (myOldFileDataTime != myNewFileDataTime) {
					
						var myNewRectangle = myActivePage.rectangles.add()
			
						myNewRectangle.place(myNewFile)
				
						Formula_Resize(myNewRectangle, dopBaseShift, ScaleFormula, myScaleFlag)
						
					} else { 
						MessageWindow("Формулу Вы не набрали!");
						myNewFile.remove() }					
			}
		
		} else {alert(err, "Ошибка MT-Script 1-08", true)}
		
		}
		
   with (app.activeDocument.viewPreferences) {

      horizontalMeasurementUnits = myOldXUnits
      verticalMeasurementUnits = myOldYUnits

    }
	
	}


// ************************************************************************************************** //

function myGetScriptPath() {
    try{
        return File(app.activeScript).parent;
    }
    catch(myError){
        return File(myError.fileName).parent;
    }
}

// ************************************************************************************************** //

	