﻿#targetengine "session"

	var myParentFolder = myGetScriptPath();
	TestMyLoad = false;
	var myResult;
	
	try { TestMyLoad = !ToLoadCommon }
	catch (err) {TestMyLoad = false}
	
	if (!TestMyLoad) {
	
			myCommonFile = new File(myParentFolder+"/MT-Common1-08.jsxbin")
			
			if (!myCommonFile.exists) {
				myCommonFile = new File(myParentFolder+"/MT-Common1-08.jsx")
				}
	
			try {
				app.doScript(myCommonFile, ScriptLanguage.JAVASCRIPT)
				//ShowLoadBasicFunctions()
				TestMyLoad = true
				}
			catch (err) {
				TestMyLoad = false
				alert(err+"\nНе удается загрузить файл с основным кодом.\nСкрипт работать не будет!", "MT-Script 1-08", true)
				}
		
	}
	

	if (TestMyLoad) {
			if (GlobalScriptPath) {mainTreat()}
			else {alert(GlStr, "MT-Script 1-08", true)}
		}

// ************************************************************************************************** //

function mainTreat() {
	
	#include "MT-Load.jsxinc"
	
	var myDocument = app.activeDocument
	var OverflowsNum = 0
	app.scriptPreferences.enableRedraw = false	

    with (app.activeDocument.viewPreferences)
	{
      myOldXUnits = horizontalMeasurementUnits;
      myOldYUnits = verticalMeasurementUnits;

      horizontalMeasurementUnits = MeasurementUnits.POINTS;
      verticalMeasurementUnits = MeasurementUnits.POINTS;
    }
	
try {
	var mySelections = myDocument.selection
	SelectionsLength = mySelections.length
	
	SelL = 0
	
	do {
		
	var mySelection = mySelections[SelL]
	//alert(mySelection.constructor.name)
	switch (mySelection.constructor.name) {
		case "Text":
		case "Paragraph":
		case "Cell":
			var myStory = mySelection
			
					var myTablesInStory = myStory.tables
						for (var i = 0; i < myTablesInStory.length; i++) {
							var myTableCells = myTablesInStory[i].cells
								for (var j = 0; j < myTableCells.length; j++) {
									var myCellText = myTableCells[j].texts[0]
									if (myCellText.contents != "") {
										TreatObject(myCellText, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
										myCellText.recompose()
										}
									}
							}			
			if (myStory.contents != "") {
				TreatObject(myStory, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
				myStory.recompose()
				}
			break;
			
		case "TextStyleRange":
		case "TextFrame":
		case "TextColumn":
			var myStory = mySelection
					var myTablesInStory = myStory.tables
						for (var i = 0; i < myTablesInStory.length; i++) {
							var myTableCells = myTablesInStory[i].cells
								for (var j = 0; j < myTableCells.length; j++) {
									var myCellText = myTableCells[j].texts[0]
									if (myCellText.contents != "") {
										TreatObject(myCellText, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
										myCellText.recompose()
										}
									}
							}			
			
			if (myStory.contents != "") {
				TreatObject(myStory, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
				myStory.recompose()
				}
			break;
			
		case "InsertionPoint":
			var myStory = GetMyLines(mySelection)
			if (myStory.contents != "") {
				TreatObject(myStory, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
				myStory.recompose()
				}
			break;

		case "Character":
			var myStory = mySelection
			if (myStory.contents != "") {
				TreatObject(myStory, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
				myStory.recompose()
				}
			break;
			
		case "WMF":
		case "EPS":
			var myObject = mySelection.parent  // Ссылка на Rectangle
			
					switch (myObject.parent.constructor.name) {
					case "Page":
					case "Spread":
						Formula_Resize (myObject, dopBaseShift, ScaleFormula, myScaleFlag)
						break;
					case "Character":
						TreatObject(myObject.parent, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
						break;
					}
		break;
		
		case "Rectangle":
					switch (mySelection.parent.constructor.name) {
					case "Page":
					case "Spread":
						Formula_Resize (mySelection, dopBaseShift, ScaleFormula, myScaleFlag)
						break;
					case "Character":
						TreatObject(mySelection.parent, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
						break;
					}
			break;
			
			case "Table":
				var myTableCells = mySelection.cells
				for (var i = 0; i < myTableCells.length; i++) {
					var myCellText = myTableCells[i].texts[0]
					if (myCellText.contents != "") {
						TreatObject(myCellText, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
						myCellText.recompose()
						}
				}		
			break;
		}	
	
		SelL++
	
	   }  while (SelL < SelectionsLength) 
	
	
	} // Конец блока try
    catch(err) {
	
	if (err.name == "TypeError") {
	   if (confirm("Ничего не выделено. Обрабатываем весь текст сразу?", false, "MT-Script 1-08: скрипт MT-TreatEq1-08")) {
			
			//try {
			
				var myPageRecs = myDocument.rectangles
				var myPageRecsLen = myPageRecs.length
						
				for (var iPRec = 0; iPRec < myPageRecsLen; iPRec++) {
					//alert(myPageRecs[iPRec].constructor.name + "  " + myPageRecsLen)
					Formula_Resize (myPageRecs[iPRec], dopBaseShift, ScaleFormula, myScaleFlag)
					}		
						
				var myStories = myDocument.stories
				myStoriesLen = myStories.length
				for (myStL = 0; myStL < myStoriesLen; myStL++) {
					var myStory = myStories.item(myStL)
					
					var myTablesInStory = myStory.tables
						for (var i = 0; i < myTablesInStory.length; i++) {
							var myTableCells = myTablesInStory[i].cells
								for (var j = 0; j < myTableCells.length; j++) {
									var myCellText = myTableCells[j].texts[0]
									if (myCellText.contents != "") {
										TreatObject(myCellText, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
										myCellText.recompose()
										}
									}
							}

				/*	if (myStory.overflows == true) {
						OverflowsNum++
						alert("MT-Script 1-08 обнаружил " + String(OverflowsNum) + "-й неразложенный текст.\nЧтобы применить интерлиньяж ко всему тексту,\nразложите его и запустите макрос еще раз.", "MT-Script 1-08", true)
						var TC_Len = myStory.textContainers.length
						for (var k = 0; k < myStory.textContainers.length; k++) {
							TreatObject(myStory.textContainers[k], dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP)
							} 
						}
					else {
						if (myStory.contents != "") {
							TreatObject(myStory, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP)
							myStory.recompose()
							}
						} */
					
						if (myStory.contents != "") {
							TreatObject(myStory, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
							myStory.recompose()}
					
					}
				//}
			//catch (err1)
				//{
					//alert(err+"\nВ публикации есть неразложенный обрабатываемый текст.\nПожалуйста, разложите его по страницам\nи запустите макрос заново", "MT-Script 1-08", true)
					//}
		}  else {alert(err, "MT-Script 1-08", true)}
	
	} // Конец блока catch 

}  // Конец блока do

	if (myCP) {
			myProgressPanel.hide()
		}
	   
    with (app.activeDocument.viewPreferences) {

      horizontalMeasurementUnits = myOldXUnits
      verticalMeasurementUnits = myOldYUnits

    }

	app.scriptPreferences.enableRedraw = true
    
   //alert ("Готово")

}


// ************************************************************************************************** //

function myGetScriptPath() {
    try{
        return File(app.activeScript).parent;
    }
    catch(myError){
        return File(myError.fileName).parent;
    }
}

// ************************************************************************************************** //

function ShowLoadBasicFunctions() {
	var win = new Window("palette", "MT-Script 1-08", undefined);
	win.stText = win.add("statictext", undefined, "Загружаю файл MT-Common1-08.jsxbin");
	win.show()
	$.sleep(1000)
	win.close()
	}

