﻿#targetengine "session"

	var myParentFolder = myGetScriptPath()
	TestMyLoad = false
	
	try { TestMyLoad = !ToLoadCommon }
	catch (err) {TestMyLoad = false}
	
	if (!TestMyLoad) {
	
			myCommonFile = new File(myParentFolder+"/MT-Common1-08.jsxbin")
			
			if (!myCommonFile.exists) {
				myCommonFile = new File(myParentFolder+"/MT-Common1-08.jsx")
				}
	
			try {
				app.doScript(myCommonFile, ScriptLanguage.JAVASCRIPT)
				TestMyLoad = true
				}
			catch (err) {
				TestMyLoad = false
				alert(err+"\nНе удается загрузить файл с основным кодом.\nСкрипт работать не будет!", "MT-Script 1-08", true)
				}
		
	}

	if (TestMyLoad) {
			if (GlobalScriptPath) {mainEdit()}
				else {alert(GlStr, "MT-Script 1-08", true)}
		} 


// ************************************************************************* //

function mainEdit() {
	
	#include "MT-Load.jsxinc"
	
   var myDocument = app.activeDocument

   with (app.activeDocument.viewPreferences)
	{
      myOldXUnits = horizontalMeasurementUnits;
      myOldYUnits = verticalMeasurementUnits;

      horizontalMeasurementUnits = MeasurementUnits.POINTS;
      verticalMeasurementUnits = MeasurementUnits.POINTS;
    } 
	
try {
    var mySelection = myDocument.selection[0]

	//alert(mySelection.graphics[0].itemLink.filePath)
	switch (mySelection.constructor.name) {
		case "Rectangle":
			//alert("Выделен " + mySelection.constructor.name);
			
			if (!myScaleFlag) {
				ScaleFormula = mySelection.graphics.item(0).verticalScale
				myScaleFlag = !myScaleFlag}
			
			if (EditMyEquation(mySelection, myDoubleFlag, myContinueFlag) == true) {
					switch (mySelection.parent.constructor.name) {
					case "Page":
					case "Spread":
						Formula_Resize (mySelection, dopBaseShift, ScaleFormula, myScaleFlag)
						break;
					case "Character":
						TreatObject(mySelection.parent, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
						break;
					}
				}

		break;
			
		case "WMF":
		case "EPS":

			if (!myScaleFlag) {
				ScaleFormula = mySelection.verticalScale
				myScaleFlag = !myScaleFlag}

			var myObject = mySelection.parent
			
			if (EditMyEquation(myObject, myDoubleFlag, myContinueFlag) == true) {
				//alert("Выделен " + myObject.parent.constructor.name);
					switch (myObject.parent.constructor.name) {
					case "Page":
					case "Spread":
						Formula_Resize (myObject, dopBaseShift, ScaleFormula, myScaleFlag)
						break;
					case "Character":
						TreatObject(myObject.parent, dopBaseShift, AlfaFormula, BetaFormula, ScaleFormula, myLeadingFlag, myScaleFlag, myCP, myDopShiftingFlag, DopShifting)
						break;
					}
				}
			
		break;
		
		default:
			alert("Выбран "+ mySelection.constructor.name + ". Это не формула." + "\nПожалуйста, выберите правильно формулу.", "Ошибка MT-Script 1-08")
		break;
		}	
	}
    catch(err)
	{ alert(err+"\nНичего не выбрано!\nПожалуйста, выберите правильно формулу.", "Ошибка MT-Script 1-08") }
		
   with (app.activeDocument.viewPreferences) {

      horizontalMeasurementUnits = myOldXUnits
      verticalMeasurementUnits = myOldYUnits

    }
	
	}


// ************************************************************************************************** //

function myGetScriptPath() {
    try{
        return File(app.activeScript).parent;
    }
    catch(myError){
        return File(myError.fileName).parent;
    }
}



	